﻿using System;
using System.Diagnostics;
using System.Net;
using System.Windows;
using System.Windows.Browser;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace PseudoTransparentBackground
{
  /// <summary>
  /// Helper class to animate the position of the Silverlight application
  /// within the browser.
  /// </summary>
  public class AppPosition : DependencyObject
  {
    public double Left
    {
      get { return (double)GetValue(LeftProperty); }
      set { SetValue(LeftProperty, value); }
    }

    public double Top
    {
      get { return (double)GetValue(TopProperty); }
      set { SetValue(TopProperty, value); }
    }

    private static void LeftChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
    {
      int x = Convert.ToInt32((double)e.NewValue);
      MainPage.Offset.TranslateX = -x;
      SilverlightControlHost.SetStyleAttribute("left", String.Format("{0}px", x));
    }

    private static void TopChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
    {
      int y = Convert.ToInt32((double)e.NewValue);
      MainPage.Offset.TranslateY = -y;
      SilverlightControlHost.SetStyleAttribute("top", String.Format("{0}px", y));
    }

    static MainPage MainPage
    {
      get
      {
        if (_mainPage == null)
          _mainPage = (MainPage)Application.Current.RootVisual;
        return _mainPage;
      }
    }
    static MainPage _mainPage;

    static readonly HtmlElement SilverlightControlHost = HtmlPage.Document.GetElementById("silverlightControlHost");

    public static readonly DependencyProperty LeftProperty = DependencyProperty.Register(
        "Left", typeof(double), typeof(AppPosition), new PropertyMetadata(LeftChanged));

    public static readonly DependencyProperty TopProperty = DependencyProperty.Register(
        "Top", typeof(double), typeof(AppPosition), new PropertyMetadata(TopChanged));
  }
}
